clear all, 
close all, 
clc
% set(0,'DefaultFigureWindowStyle','normal')

run('../Bibliotecas/parametrosFiguras.m')
%%
s = tf('s')
Ts = 0.1

G = 2*(-0.75*s+1)/(1.5*s+1)^2;

% figure
% step(G)

%%

Gz = c2d(G,Ts,'zoh');
num = Gz.num{1};
den = Gz.den{1};
na = size(den,2)-1;
nb = size(num,2)-2;
dd = Gz.inputdelay;


M = ceil(10/Ts)
M=150;

Gcoef = step(G,Ts:Ts:2*M*Ts);

%% parâmetros de ajuste

N1 = 1;
N2 = 30;
N = N2-N1+1;
Nu = 5;

delta = 1;
lambda = .1;
lambdaM = 1000;


%% montando as matrizes do DMC

G = zeros(N2,Nu);
G(:,1) = Gcoef(1:N2,1);


for i=2:Nu
    G(i:end,i) = G(1:end-(i-1),1);    
end

G = G(N1:end,:);

Qy = delta*eye(N2-N1+1);
Qu = lambda*eye(Nu);

Kdmc = inv(G'*Qy*G+Qu)*G'*Qy

Kdmc1 = Kdmc(1,:);

Ylivre = zeros(M,1); %%% 0 é o valor inicial da saída do sistema em regime permanente

%%% ajuste das matrizes para o caso com restrição.
Hot = 2*(G'*Qy*G+Qu);
bot = -2*G'*Qy;

Hot1 = blkdiag(Hot, 2*lambdaM);
Hot2 = blkdiag(Hot, diag(2*lambdaM*ones(N2-N1+1,1)));

LB1 = [-inf*ones(Nu,1);0];
UB1 = [inf*ones(Nu,1);inf];

LB2 = [-inf*ones(Nu,1);zeros(N2-N1+1,1)];
UB2 = [inf*ones(Nu,1);inf*ones(N2-N1+1,1)];

%% inicialização vetores
nin = M+1;
nit = round(25/Ts) + nin;

entradas = zeros(nit,1);
du = zeros(nit,1);

saidas = 0*ones(nit,1);

perts = zeros(nit,1);
perts(nin+round(15/Ts):end) = -1;

Ta=20; %T ambiente
refs = 0*ones(nit,1);
refs(nin+round(2/Ts):nit) = 5;
refs(nin+round(8/Ts):nit) = 2;
% refs(nin+850:end) = 4;


erro = zeros(nit,1);

%% Caso DMC com restrições
Ylivre = zeros(M,1); %%% 0 é o valor inicial da saída do sistema em regime permanente

%% simulação sem filtro de referência
for i = nin:nit
    %% modelo processo, não mexer
    saidas(i) = -den(2:end)*saidas(i-1:-1:i-na) + num*(entradas(i-dd:-1:i-nb-dd-1) + perts(i-dd:-1:i-dd-nb-1));
    
    %% Controlador
    Ylivre = Ylivre + Gcoef(1:M,1)*du(i-1);
    
    eta = saidas(i)-Ylivre(1); %%% erro de predição
    
    Ylivre(1:end-1) = Ylivre(2:end); %%% deslocamento do vetor
    
    %%% resposta livre
    f = Ylivre(N1:N2,1)+eta;
    
    %%% referências
    R = ones(N2-N1+1,1)*refs(i);
    %R = refs(i+N1:i+N2); %%% uso de referencias futuras
    
    %%% restrições
    if(refs(i)==saidas(i))
        X = quadprog(Hot2,[bot*(R-f); zeros(N2-N1+1,1)]);
    elseif(refs(i)>saidas(i))
        Arest = [-G diag(-ones(N2-N1+1,1))];
        X = quadprog(Hot2,[bot*(R-f); zeros(N2-N1+1,1)], Arest,-saidas(i)+f,[],[],LB2,UB2);
    else
        Arest = [G diag(-ones(N2-N1+1,1))];
        X = quadprog(Hot2,[bot*(R-f); zeros(N2-N1+1,1)],  Arest,saidas(i)-f,[],[],LB2,UB2);
    end
    %%% calculo do incremento de controle ótimo    

    du(i) = X(1);
    xi2(:,i) = X(Nu+1:end);
    
    %%% calculo da ação de controle real
    entradas(i) = entradas(i-1)+du(i);
        
    
end

saidasDMCrest2 = saidas;
entradasDMCrest2 = entradas;
duDMCrest2 = du;

figure
subplot(2,1,1)
plot(saidas)
hold on
plot(refs)
subplot(2,1,2)
plot(entradas)


%% Caso DMC com restrições
entradas = zeros(nit,1);
du = zeros(nit,1);
saidas = 0*ones(nit,1);
Ylivre = zeros(M,1); %%% 0 é o valor inicial da saída do sistema em regime permanente

%% simulação sem filtro de referência
for i = nin:nit
    %% modelo processo, não mexer
    saidas(i) = -den(2:end)*saidas(i-1:-1:i-na) + num*(entradas(i-dd:-1:i-nb-dd-1) + perts(i-dd:-1:i-dd-nb-1));
    
    %% Controlador
    Ylivre = Ylivre + Gcoef(1:M,1)*du(i-1);
    
    eta = saidas(i)-Ylivre(1); %%% erro de predição
    
    Ylivre(1:end-1) = Ylivre(2:end); %%% deslocamento do vetor
    
    %%% resposta livre
    f = Ylivre(N1:N2,1)+eta;
    
    %%% referências
    R = ones(N2-N1+1,1)*refs(i);
    %R = refs(i+N1:i+N2); %%% uso de referencias futuras
    
    %%% restrições
    if(refs(i)==saidas(i))
        X = quadprog(Hot1,[bot*(R-f); 0]);
    elseif(refs(i)>saidas(i))
        Arest = [-G -ones(N2-N1+1,1)];
        X = quadprog(Hot1,[bot*(R-f); 0], Arest,-saidas(i)+f,[],[],LB1,UB1);
    else
        Arest = [G -ones(N2-N1+1,1)];
        X = quadprog(Hot1,[bot*(R-f); 0],  Arest,saidas(i)-f,[],[],LB1,UB1);
    end
    %%% calculo do incremento de controle ótimo    

    du(i) = X(1);
    xi1(i) = X(end);
    
    %%% calculo da ação de controle real
    entradas(i) = entradas(i-1)+du(i);
        
    
end

saidasDMCrest = saidas;
entradasDMCrest = entradas;
duDMCrest = du;

figure
subplot(2,1,1)
plot(saidas)
hold on
plot(refs)
subplot(2,1,2)
plot(entradas)


%% plots
ind = nin:nit;
t = (ind-nin)*Ts;

cores = gray(4);
cores = cores(1:end-1,:);


hf = figure
h=subplot(2,1,1)
plot(t,saidasDMCrest(ind),'-.','LineWidth',tamlinha,'Color',cores(1,:))
hold on
plot(t,saidasDMCrest2(ind),'LineWidth',tamlinha,'Color',cores(2,:))
plot(t,refs(ind),'--','LineWidth',tamlinha,'Color',cores(3,:))


ylabel('Controlada', 'FontSize', tamletra);
% ylim([50 60]);
hl = legend('Caso 1','Caso 2','Referência')
% hl.Position = [0.6685 0.6029 0.2375 0.1107];

grid on


set(h, 'FontSize', tamletra);

h=subplot(2,1,2)
plot(t,entradasDMCrest(ind),'-.','LineWidth',tamlinha,'Color',cores(1,:))
hold on
plot(t,entradasDMCrest2(ind),'LineWidth',tamlinha,'Color',cores(2,:))
ylabel('Manipulada', 'FontSize', tamletra);
xlabel('Tempo (segundos)', 'FontSize', tamletra);
% ylim([20 50]);
set(h, 'FontSize', tamletra);

grid on

% h=subplot(3,1,3)
% plot(t,erro(1:nit-N2-1),'LineWidth',tamlinha)
% title('Erro', 'FontSize', tamletra);
% xlabel('tempo', 'FontSize', tamletra);
% set(h, 'FontSize', tamletra);

hf.Position = tamfigura;
hl.Position = [0.7077 0.5411 0.2054 0.1242];


print('ex_rest_inversa2','-depsc')
% print('ex_rest_inversa_pb','-deps')

%%
hf = figure
plot(t,xi1(ind),'-.','LineWidth',tamlinha,'Color',cores(1,:))
hold on
plot(t,max(xi2(:,ind)),'LineWidth',tamlinha,'Color',cores(2,:))


ylabel('Valor Relaxação', 'FontSize', tamletra);
xlabel('Tempo (segundos)', 'FontSize', tamletra);
% set(hf, 'FontSize', tamletra);
hl = legend('Caso 1','Caso 2')

grid on

hf.Position = tamfigura;


print('ex_rest_inversa2_xi','-depsc')


