clear all, 
close all, 
clc
% set(0,'DefaultFigureWindowStyle','normal')

run('../Bibliotecas/parametrosFiguras.m')
%%
s = tf('s')
Ts = 0.1

% G = 4*(-0.5*s+1)/(s+2)^2;

G = 4/(s+1)^2;
% G = 4/(2*s+1)/(s+1)
%G = 4/(s+2)^2*exp(-10*Ts*s);

% G = 4*(s+3)*(s+0.5)/(s^2+4*s+4.25)/(s+2)^4*exp(-20*Ts*s);


% figure
% step(G)

%%

Gz = c2d(G,Ts,'zoh');
num = Gz.num{1};
den = Gz.den{1};
na = size(den,2)-1;
nb = size(num,2)-2;
dd = Gz.inputdelay;


M = ceil(10/Ts)
M=100;

Gcoef = step(G,Ts:Ts:10);
Gqcoef = step(G,0:Ts:10);

%% parâmetros de ajuste

N1 = 1;
N2 = 90;
Nu = 25;

delta = 1;
lambda = 1;


%% montando as matrizes do DMC

G = zeros(N2,Nu);
G(:,1) = Gcoef(1:N2,1);


for i=2:Nu
    G(i:end,i) = G(1:end-(i-1),1);    
end

G = G(N1:end,:);

Qy = delta*eye(N2-N1+1);
Qu = lambda*eye(Nu);

Kdmc = inv(G'*Qy*G+Qu)*G'*Qy

Kdmc1 = Kdmc(1,:);

Ylivre = ones(M,1)*0; %%% 0 é o valor inicial da saída do sistema em regime permanente


%%% ajuste das matrizes para o caso com restrição.
Arest = G;

Hot = 2*(G'*Qy*G+Qu);
bot = -2*G'*Qy;

%% inicialização vetores
duAnt = 0;
uAnt = 0;

nin = M+1;
nit = round(18/Ts) + nin;

entradas = zeros(nit,1);
du = zeros(nit,1);

saidas = 0*ones(nit,1);

perts = zeros(nit,1);
perts(nin+round(12/Ts):end) = -1;

Ta=20; %T ambiente
refs = 0*ones(nit,1);
refs(nin+round(2/Ts):nit) = 5;
refs(nin+round(8/Ts):nit) = 2;
% refs(nin+850:end) = 4;


erro = zeros(nit,1);

%% simulação sem filtro de referência
for i = nin:nit
    %% modelo processo, não mexer
    saidas(i) = -den(2:end)*saidas(i-1:-1:i-na) + num*(entradas(i-dd:-1:i-nb-dd-1) + perts(i-dd:-1:i-dd-nb-1));
    
    erro(i) = refs(i)-saidas(i);
    
    %% Controlador
    Ylivre = Ylivre + Gcoef(1:M,1)*duAnt;
    
    eta = saidas(i)-Ylivre(1); %%% erro de predição
    
    Ylivre(1:end-1) = Ylivre(2:end); %%% deslocamento do vetor
    
    %%% resposta livre
    f = Ylivre(N1:N2,1)+eta;
    
    %%% referências
    R = ones(N2-N1+1,1)*refs(i);
    %R = refs(i+N1:i+N2); %%% uso de referencias futuras
    
    %%% calculo do incremento de controle ótimo    
    duAtual = Kdmc1*(R-f);
    
    %%% calculo da ação de controle real
    uAtual = duAtual + uAnt;
    
    %%% aplicar no sistema
    entradas(i) = uAtual;
    
    %%% atualização
    
    uAnt = uAtual;
    duAnt = duAtual;
    
    
end

saidasDMC = saidas;
entradasDMC = entradas;
duDMC = du;

figure
subplot(2,1,1)
plot(saidas)
hold on
plot(refs)
subplot(2,1,2)
plot(entradas)


%% Caso DMC com restrições
entradas = zeros(nit,1);
du = zeros(nit,1);
saidas = 0*ones(nit,1);
Ylivre = zeros(M,1); %%% 0 é o valor inicial da saída do sistema em regime permanente

%% simulação sem filtro de referência
for i = nin:nit
    %% modelo processo, não mexer
    saidas(i) = -den(2:end)*saidas(i-1:-1:i-na) + num*(entradas(i-dd:-1:i-nb-dd-1) + perts(i-dd:-1:i-dd-nb-1));
    
    %% Controlador
    Ylivre = Ylivre + Gcoef(1:M,1)*du(i-1);
    
    eta = saidas(i)-Ylivre(1); %%% erro de predição
    
    Ylivre(1:end-1) = Ylivre(2:end); %%% deslocamento do vetor
    
    %%% resposta livre
    f = Ylivre(N1:N2,1)+eta;
    
    %%% referências
    R = ones(N2-N1+1,1)*refs(i);
    %R = refs(i+N1:i+N2); %%% uso de referencias futuras
    
    %%% restrições
    if(refs(i)==saidas(i))
        X = quadprog(Hot,bot*(R-f));
    elseif(refs(i)>saidas(i))
        X = quadprog(Hot,bot*(R-f), Arest,R-f);
    else
        X = quadprog(Hot,bot*(R-f),-Arest,f-R);
    end
    %%% calculo do incremento de controle ótimo    

    du(i) = X(1);
    
    %%% calculo da ação de controle real
    entradas(i) = entradas(i-1)+du(i);
        
    
end

saidasDMCrest = saidas;
entradasDMCrest = entradas;
duDMCrest = du;

figure
subplot(2,1,1)
plot(saidas)
hold on
plot(refs)
subplot(2,1,2)
plot(entradas)


%% plots
ind = nin:nit;
t = (ind-nin)*Ts;

cores = gray(4);
cores = cores(1:end-1,:);

hf = figure
h=subplot(2,1,1)
plot(t,saidasDMC(ind)+52,'-.','LineWidth',tamlinha,'Color',cores(1,:))
hold on
plot(t,saidasDMCrest(ind)+52,'LineWidth',tamlinha,'Color',cores(2,:))
plot(t,refs(ind)+52,'--','LineWidth',tamlinha,'Color',cores(3,:))


ylabel('Nível (%)', 'FontSize', tamletra);
ylim([50 60]);
hl = legend('S/ restrição','C/ restrição','Referência')
% hl.Position = [0.6685 0.6029 0.2375 0.1107];

grid on


set(h, 'FontSize', tamletra);

h=subplot(2,1,2)
plot(t,entradasDMC(ind)+30,'-.','LineWidth',tamlinha,'Color',cores(1,:))
hold on
plot(t,entradasDMCrest(ind)+30,'LineWidth',tamlinha,'Color',cores(2,:))
ylabel('Manipulada (%)', 'FontSize', tamletra);
xlabel('Tempo (minutos)', 'FontSize', tamletra);
ylim([20 50]);
set(h, 'FontSize', tamletra);

grid on

% h=subplot(3,1,3)
% plot(t,erro(1:nit-N2-1),'LineWidth',tamlinha)
% title('Erro', 'FontSize', tamletra);
% xlabel('tempo', 'FontSize', tamletra);
% set(h, 'FontSize', tamletra);

hf.Position = tamfigura;
hl.Position = [0.7077 0.5411 0.2054 0.1242];


print('ex_rest_sempico','-depsc')
print('ex_rest_sempico_pb','-deps')



