clear all, 
close all, 
clc
% set(0,'DefaultFigureWindowStyle','normal')

run('../Bibliotecas/parametrosFiguras.m')
%%
s = tf('s')
Ts = 0.1

% G = 4*(-0.5*s+1)/(s+2)^2;

G = 4/(s+1)^2;
% G = 4/(2*s+1)/(s+1)
%G = 4/(s+2)^2*exp(-10*Ts*s);

% G = 4*(s+3)*(s+0.5)/(s^2+4*s+4.25)/(s+2)^4*exp(-20*Ts*s);


% figure
% step(G)

%%

Gz = c2d(G,Ts,'zoh');
num = Gz.num{1};
den = Gz.den{1};
na = size(den,2)-1;
nb = size(num,2)-2;
dd = Gz.inputdelay;


M = ceil(10/Ts)
M=100;

Gcoef = step(G,Ts:Ts:10);
Gqcoef = step(G,0:Ts:10);

%% parâmetros de ajuste

N1 = 1;
N2 = 30;
N = N2-N1+1;
Nu = 5;

delta = 1;
lambda = 1;
lambdaU = 0.4;
lambdaU2 = 5;
deltaM = 1000;


%% montando as matrizes do DMC

G = zeros(N2,Nu);
G(:,1) = Gcoef(1:N2,1);


for i=2:Nu
    G(i:end,i) = G(1:end-(i-1),1);    
end

G = G(N1:end,:);

Qy = delta*eye(N2-N1+1);
Qu = lambda*eye(Nu);
QU = lambdaU*eye(Nu);
QU2 = lambdaU2*eye(Nu);

TU = tril(ones(Nu));


Kdmc = inv(G'*Qy*G+Qu)*G'*Qy
Kdmc1 = Kdmc(1,:);


Kdmc2f = inv(G'*Qy*G + Qu + TU'*QU*TU)*G'*Qy;
Kdmc2f = Kdmc2f(1,:);
Kdmc2u = inv(G'*Qy*G + Qu + TU'*QU*TU)*TU'*QU;
Kdmc2u = Kdmc2u(1,:);


Kdmc3f = inv(G'*Qy*G + Qu + TU'*QU2*TU)*G'*Qy;
Kdmc3f = Kdmc3f(1,:);
Kdmc3u = inv(G'*Qy*G + Qu + TU'*QU2*TU)*TU'*QU2;
Kdmc3u = Kdmc3u(1,:);



Ylivre = zeros(M,1); %%% 0 é o valor inicial da saída do sistema em regime permanente


%% inicialização vetores
nin = M+1;
nit = round(18/Ts) + nin;

entradas = zeros(nit,1);
du = zeros(nit,1);

saidas = 0*ones(nit,1);

perts = zeros(nit,1);
perts(nin+round(8/Ts):end) = -2;
% perts(nin+round(20/Ts):end) = -1;

Ta=20; %T ambiente
refs = 0*ones(nit,1);
refs(nin+round(2/Ts):nit) = 3;
% refs(nin+round(8/Ts):nit) = 0;
% refs(nin+850:end) = 4;

refsu = zeros(nit,1);

erro = zeros(nit,1);

%% Caso 1
for i = nin:nit
    %% modelo processo, não mexer
    saidas(i) = -den(2:end)*saidas(i-1:-1:i-na) + num*(entradas(i-dd:-1:i-nb-dd-1) + perts(i-dd:-1:i-dd-nb-1));
    
    erro(i) = refs(i)-saidas(i);
    
    %% Controlador
    Ylivre = Ylivre + Gcoef(1:M,1)*du(i-1);
    
    eta = saidas(i)-Ylivre(1); %%% erro de predição
    
    Ylivre(1:end-1) = Ylivre(2:end); %%% deslocamento do vetor
    
    %%% resposta livre
    f = Ylivre(N1:N2,1)+eta;
    
    %%% referências
    R = ones(N2-N1+1,1)*refs(i);
    %R = refs(i+N1:i+N2); %%% uso de referencias futuras
    
    %%% calculo do incremento de controle ótimo    
    
    du(i) = Kdmc1*(R-f);    
    
    %%% aplicar no sistema
    entradas(i) = entradas(i-1)+du(i);    
    
end

saidasDMC = saidas;
entradasDMC = entradas;
duDMC = du;

figure
subplot(2,1,1)
plot(saidas)
hold on
plot(refs)
subplot(2,1,2)
plot(entradas)


%% Caso 2
entradas = zeros(nit,1);
du = zeros(nit,1);
saidas = 0*ones(nit,1);
Ylivre = zeros(M,1); %%% 0 é o valor inicial da saída do sistema em regime permanente

for i = nin:nit
    %% modelo processo, não mexer
    saidas(i) = -den(2:end)*saidas(i-1:-1:i-na) + num*(entradas(i-dd:-1:i-nb-dd-1) + perts(i-dd:-1:i-dd-nb-1));
    
    %% Controlador
    Ylivre = Ylivre + Gcoef(1:M,1)*du(i-1);
    
    eta = saidas(i)-Ylivre(1); %%% erro de predição
    
    Ylivre(1:end-1) = Ylivre(2:end); %%% deslocamento do vetor
    
    %%% resposta livre
    f = Ylivre(N1:N2,1)+eta;
    fu = (refsu(i)-entradas(i-1))*ones(Nu,1);
    %%% referências
    R = ones(N2-N1+1,1)*refs(i);

    du(i) = Kdmc2f*(R-f) + Kdmc2u*fu;
    
    %%% calculo da ação de controle real
    entradas(i) = entradas(i-1)+du(i);
        
    
end

saidasDMC2 = saidas;
entradasDMC2 = entradas;
duDMC2 = du;

figure
subplot(2,1,1)
plot(saidas)
hold on
plot(refs)
subplot(2,1,2)
plot(entradas)

%% Caso 3
entradas = zeros(nit,1);
du = zeros(nit,1);
saidas = 0*ones(nit,1);
Ylivre = zeros(M,1); %%% 0 é o valor inicial da saída do sistema em regime permanente

for i = nin:nit
    %% modelo processo, não mexer
    saidas(i) = -den(2:end)*saidas(i-1:-1:i-na) + num*(entradas(i-dd:-1:i-nb-dd-1) + perts(i-dd:-1:i-dd-nb-1));
    
    %% Controlador
    Ylivre = Ylivre + Gcoef(1:M,1)*du(i-1);
    
    eta = saidas(i)-Ylivre(1); %%% erro de predição
    
    Ylivre(1:end-1) = Ylivre(2:end); %%% deslocamento do vetor
    
    %%% resposta livre
    f = Ylivre(N1:N2,1)+eta;
    fu = (refsu(i)-entradas(i-1))*ones(Nu,1);
    %%% referências
    R = ones(N2-N1+1,1)*refs(i);

    du(i) = Kdmc3f*(R-f) + Kdmc3u*fu;
    
    %%% calculo da ação de controle real
    entradas(i) = entradas(i-1)+du(i);
        
    
end

saidasDMC3 = saidas;
entradasDMC3 = entradas;
duDMC3 = du;

figure
subplot(2,1,1)
plot(saidas)
hold on
plot(refs)
subplot(2,1,2)
plot(entradas)


%% plots
ind = nin:nit;
t = (ind-nin)*Ts;

cores = gray(5);
cores = cores(1:end-1,:);

hf = figure
h=subplot(2,1,1)
plot(t,saidasDMC(ind)+52,'LineWidth',tamlinha,'Color',cores(1,:))
hold on
plot(t,saidasDMC2(ind)+52,'-.','LineWidth',tamlinha,'Color',cores(2,:))
plot(t,saidasDMC3(ind)+52,':','LineWidth',tamlinha,'Color',cores(3,:))

plot(t,refs(ind)+52,'--','LineWidth',tamlinha,'Color',cores(4,:))


ylabel('Nível (%)', 'FontSize', tamletra);
ylim([45 56]);
hl = legend('Caso 1','Caso 2','Caso 3','Referência')
% hl.Position = [0.6685 0.6029 0.2375 0.1107];

grid on


set(h, 'FontSize', tamletra);

h=subplot(2,1,2)
plot(t,entradasDMC(ind)+30,'LineWidth',tamlinha,'Color',cores(1,:))
hold on
plot(t,entradasDMC2(ind)+30,'-.','LineWidth',tamlinha,'Color',cores(2,:))
plot(t,entradasDMC3(ind)+30,':','LineWidth',tamlinha,'Color',cores(3,:))

plot(t,refsu(ind)+30,'--','LineWidth',tamlinha,'Color',cores(4,:))

ylabel('Manipulada (%)', 'FontSize', tamletra);
xlabel('Tempo (minutos)', 'FontSize', tamletra);
ylim([29 35]);
set(h, 'FontSize', tamletra);

grid on

% h=subplot(3,1,3)
% plot(t,erro(1:nit-N2-1),'LineWidth',tamlinha)
% title('Erro', 'FontSize', tamletra);
% xlabel('tempo', 'FontSize', tamletra);
% set(h, 'FontSize', tamletra);

hf.Position = tamfigura;
hl.Position = [0.1448 0.4987 0.2054 0.2348];


print('ex_utarget','-depsc')
% print('ex_rest_monotonica_pb','-deps')



