z = tf('z',Ts);
F = tf(0,1,Ts);
nf = 2;

pz = pole(Gz); % obtem o polo indesejado (instável) de malha aberta

for i=N1(1):N2(1)
    %%% monta sistema para obtenção dos parâmetros do filtro
    %%% primeira equação (z^i - F_i(z) = 0 -> para z=pz
    %%% segunda equação F_i(1) = 0 -> força ganho unitário
    indf = i-N1(1)+1;
    Af = [pz 1;
          1 1];
    bf = [pz^i*(pz-betaf)^2;
          (1-betaf)^2];
    X = Af\bf;
    F(indf,1) = (X(1)*z+X(2))/(z-betaf)^2;
    %%% teste da condição
%     pz^i-(X(1)*pz+X(2))/(pz-betaf)^2

    %%% armazena coeficientes gtil
    modDegrauUF{i} = filter(F(indf,1).num{1},F(indf,1).den{1},modDegrauU);

end


%%% calcula a matriz H para o cálculo da resposta livre no caso GDMC
H1 = [];
H2 = [];

for i=N1(1):N2(1)
    H1 = [H1;modDegrauU(i+1:i+Nf)'];
    H2 = [H2;modDegrauUF{i}(1:Nf)'];
    
end
H = H1-H2

%% Simulação do caso GDMC
%%% inicializacao dos estados e variaveis da simulação
saidas = Cobar*ones(1,nit); % vetor da saída
entradas = Cfbar*ones(1,nit); % vetor do sinal de controle
% Du = zeros(1,nit); % vetor dos sinais de controle em torno do ponto de operação
du = zeros(1,nit); % vetor dos incrementos de controle
yfilt = Cobar*ones(Ny(1),nit);


for k = nin:nit
    %% -- simulador
    saidas(k) = simModelo(saidas(k-1),entradas(k-1)+perts(k-1),Ts);
    
    %% -- Controlador GDMC 
    %%% referencias
    R = repelem(refs(k),Ny');
    
    %%% calculo da resposta livre
    for i=1:Ny(1)
        yfilt(i,k) = -F(i,1).den{1}(2:end)*yfilt(i,k-1:-1:k-nf)' + F(i,1).num{1}*saidas(1,k:-1:k-nf)';
    end
    
    f = H*du(1,k-1:-1:k-Nf)' + yfilt(:,k);
    
    %% Resolve o problema de otimização
    boti = boti1*(R(:)-f);
    
    brest = [repelem(umax'-entradas(:,k-1),Nu)';
             repelem(entradas(:,k-1)-umin',Nu)';
             ymax-f;
             -ymin+f];
    X = quadprog(Hoti,boti,Arest,brest,[],[],LB,UB);
    
    du(k) = X(1);
%     du(:,k) = Kdmc1*(R-f);
    entradas(:,k) = entradas(:,k-1)+du(:,k);

end