clear all, 
close all, 
clc
% set(0,'DefaultFigureWindowStyle','normal')
run('../../Bibliotecas/parametrosFiguras.m')

%%
s = tf('s')
Ts = 0.1

% G = 4*(-0.5*s+1)/(s+2)^2;

G = 4/(s+1)^2;
G = 4/(2*s+1)/(s+1);
%G = 4/(s+2)^2*exp(-10*Ts*s);

% G = 4*(s+3)*(s+0.5)/(s^2+4*s+4.25)/(s+2)^4*exp(-20*Ts*s);


% figure
% step(G)

%%

Gz = c2d(G,Ts,'zoh');
num = Gz.num{1};
den = Gz.den{1};
na = size(den,2)-1;
nb = size(num,2)-2;
dd = Gz.inputdelay;


M = ceil(10/Ts)
M=100;

Gcoef = step(G,Ts:Ts:10);
Gqcoef = step(-G,0:Ts:10);

%% parmetros de ajuste

N1 = 1;
N2 = 15;
Nu = 3;

delta = 1;
lambda = 0.1;


%% montando as matrizes do DMC

G = zeros(N2,Nu);
G(:,1) = Gcoef(1:N2,1);


for i=2:Nu
    G(i:end,i) = G(1:end-(i-1),1);    
end

G = G(N1:end,:);

Qy = delta*eye(N2-N1+1);
Qu = lambda*eye(Nu);

Kdmc = inv(G'*Qy*G+Qu)*G'*Qy

Kdmc1 = Kdmc(1,:);

Ylivre = ones(M,1)*0; %%% 0  o valor inicial da sada do sistema em regime permanente


%% inicializao vetores e simulao sem FF
duAnt = 0;
uAnt = 0;

nin = M+1;
nit = 550 + nin;

entradas = zeros(nit,1);
du = zeros(nit,1);

saidas = 0*ones(nit,1);

perts = zeros(nit,1);
perts(nin+100:end) = -1;
perts(nin+250:end) = 1;


Ta=20; %T ambiente
refs = 0*ones(nit,1);
refs(nin+0:nit) = 5;
refs(nin+250:nit) = 5;
refs(nin+850:end) = 5;

%filtro ref
af=0.8;

refsf=filter(1-af,[1 -af],refs);

erro = zeros(nit,1);

% controle FF ativado se FF=1 e desativado FF=0

FF=0;

%% simulao
for i = nin:nit-N2-1
    %% modelo processo, no mexer
    saidas(i) = -den(2:end)*saidas(i-1:-1:i-na) + num*(entradas(i-dd:-1:i-nb-dd-1) - 1*perts(i-dd:-1:i-dd-nb-1));
    
    erro(i) = refs(i)-saidas(i);
    
    %% Controlador
    dq = perts(i)-perts(i-1);
%     dq = 0;
    
    Ylivre = Ylivre + Gcoef(1:M,1)*duAnt + FF*Gqcoef(1:M,1)*dq;
    
    eta = saidas(i)-Ylivre(1); %%% erro de predio
    
    Ylivre(1:end-1) = Ylivre(2:end); %%% deslocamento do vetor
    
    %%% resposta livre
    f = Ylivre(N1:N2,1)+eta;
    
    %%% referncias
     R = ones(N2-N1+1,1)*refsf(i);
    %R = refs(i+N1:i+N2); %%% uso de referencias futuras
    
    %%% calculo do incremento de controle timo    
    duAtual = Kdmc1*(R-f);
    
    %%% calculo da ao de controle real
    uAtual = duAtual + uAnt;
    
    %%% aplicar no sistema
    entradas(i) = uAtual;
    
    %%% atualizao
    
    uAnt = uAtual;
    duAnt = duAtual;
    
    
end

%% plots
t = (1:nit-N2-1)*Ts;
cores = gray(5);
cores = cores(1:end-1,:);


hf = figure
h=subplot(2,1,1)
plot(t,refs(1:nit-N2-1),'--','Color',cores(1,:),'LineWidth',tamlinha)
hold on
plot(t,saidas(1:nit-N2-1),'-','LineWidth',tamlinha,'Color',cores(2,:))
ylabel('Nvel (%)', 'FontSize', tamletra);
axis([0 50 0 7]);
grid on

legend('Sada','Referncia','Location','SouthEast');

set(h, 'FontSize', tamletra);

h=subplot(2,1,2)
plot(t,entradas(1:nit-N2-1),'-','Color',cores(2,:),'LineWidth',tamlinha)
hold on
plot(t,perts(1:nit-N2-1),'--','LineWidth',tamlinha,'Color',cores(3,:))
ylabel('Entradas (%)', 'FontSize', tamletra);
legend('Controle','Perturbao');
xlabel('Tempo (minutos)', 'FontSize', tamletra);
axis([0 50 -5 10]);
set(h, 'FontSize', tamletra);
grid on

% h=subplot(3,1,3)
% plot(t,erro(1:nit-N2-1),'LineWidth',tamlinha)
% title('Erro', 'FontSize', tamletra);
% xlabel('tempo', 'FontSize', tamletra);
% set(h, 'FontSize', tamletra);

hf.Position = tamfigura;
print('ex_tanque_com_ff_sem','-depsc')
print('ex_tanque_com_ff_sem_pb','-deps')

%% inicializao vetores e simulao com FF
duAnt = 0;
uAnt = 0;

nin = M+1;
nit = 550 + nin;

entradas = zeros(nit,1);
du = zeros(nit,1);

saidas = 0*ones(nit,1);

perts = zeros(nit,1);
perts(nin+100:end) = -1;
perts(nin+250:end) = 1;


Ta=20; %T ambiente
refs = 0*ones(nit,1);
refs(nin+0:nit) = 5;
refs(nin+250:nit) = 5;
refs(nin+850:end) = 5;

%filtro ref
af=0.8;

refsf=filter(1-af,[1 -af],refs);

erro = zeros(nit,1);

% controle FF ativado se FF=1 e desativado FF=0

FF=1;

%% simulao
for i = nin:nit-N2-1
    %% modelo processo, no mexer
    saidas(i) = -den(2:end)*saidas(i-1:-1:i-na) + num*(entradas(i-dd:-1:i-nb-dd-1) - 1*perts(i-dd:-1:i-dd-nb-1));
    
    erro(i) = refs(i)-saidas(i);
    
    %% Controlador
    dq = perts(i)-perts(i-1);
%     dq = 0;
    
    Ylivre = Ylivre + Gcoef(1:M,1)*duAnt + FF*Gqcoef(1:M,1)*dq;
    
    eta = saidas(i)-Ylivre(1); %%% erro de predio
    
    Ylivre(1:end-1) = Ylivre(2:end); %%% deslocamento do vetor
    
    %%% resposta livre
    f = Ylivre(N1:N2,1)+eta;
    
    %%% referncias
     R = ones(N2-N1+1,1)*refsf(i);
    %R = refs(i+N1:i+N2); %%% uso de referencias futuras
    
    %%% calculo do incremento de controle timo    
    duAtual = Kdmc1*(R-f);
    
    %%% calculo da ao de controle real
    uAtual = duAtual + uAnt;
    
    %%% aplicar no sistema
    entradas(i) = uAtual;
    
    %%% atualizao
    
    uAnt = uAtual;
    duAnt = duAtual;
    
    
end

%% plots
t = (1:nit-N2-1)*Ts;

hf = figure
h=subplot(2,1,1)
plot(t,refs(1:nit-N2-1),'--','Color',cores(1,:),'LineWidth',tamlinha)
hold on
plot(t,saidas(1:nit-N2-1),'-','LineWidth',tamlinha,'Color',cores(2,:))
ylabel('Nvel (%)', 'FontSize', tamletra);
axis([0 50 0 7]);
grid on

legend('Sada','Referncia','Location','SouthEast');

set(h, 'FontSize', tamletra);

h=subplot(2,1,2)
plot(t,entradas(1:nit-N2-1),'-','Color',cores(2,:),'LineWidth',tamlinha)
hold on
plot(t,perts(1:nit-N2-1),'--','LineWidth',tamlinha,'Color',cores(3,:))
ylabel('Entradas (%)', 'FontSize', tamletra);
legend('Controle','Perturbao');
xlabel('Tempo (minutos)', 'FontSize', tamletra);
axis([0 50 -5 10]);
set(h, 'FontSize', tamletra);
grid on

% h=subplot(3,1,3)
% plot(t,erro(1:nit-N2-1),'LineWidth',tamlinha)
% title('Erro', 'FontSize', tamletra);
% xlabel('tempo', 'FontSize', tamletra);
% set(h, 'FontSize', tamletra);
hf.Position = tamfigura;

print('ex_tanque_com_ff_com','-depsc')
print('ex_tanque_com_ff_com_pb','-deps')

%% simulao do sistema com FF mas mudando o lambda

lambda = 2;

Qy = delta*eye(N2-N1+1);
Qu = lambda*eye(Nu);

Kdmc = inv(G'*Qy*G+Qu)*G'*Qy

Kdmc1 = Kdmc(1,:);

Ylivre = ones(M,1)*0; %%% 0  o valor inicial da sada do sistema em regime permanente


%% inicializao vetores e simulao com FF
duAnt = 0;
uAnt = 0;

nin = M+1;
nit = 550 + nin;

entradas = zeros(nit,1);
du = zeros(nit,1);

saidas = 0*ones(nit,1);

perts = zeros(nit,1);
perts(nin+100:end) = -1;
perts(nin+250:end) = 1;


Ta=20; %T ambiente
refs = 0*ones(nit,1);
refs(nin+0:nit) = 5;
refs(nin+250:nit) = 5;
refs(nin+850:end) = 5;

%filtro ref
af=0.8;

refsf=filter(1-af,[1 -af],refs);

erro = zeros(nit,1);

% controle FF ativado se FF=1 e desativado FF=0

FF=1;

%% simulao
for i = nin:nit-N2-1
    %% modelo processo, no mexer
    saidas(i) = -den(2:end)*saidas(i-1:-1:i-na) + num*(entradas(i-dd:-1:i-nb-dd-1) - 1*perts(i-dd:-1:i-dd-nb-1));
    
    erro(i) = refs(i)-saidas(i);
    
    %% Controlador
    dq = perts(i)-perts(i-1);
%     dq = 0;
    
    Ylivre = Ylivre + Gcoef(1:M,1)*duAnt + FF*Gqcoef(1:M,1)*dq;
    
    eta = saidas(i)-Ylivre(1); %%% erro de predio
    
    Ylivre(1:end-1) = Ylivre(2:end); %%% deslocamento do vetor
    
    %%% resposta livre
    f = Ylivre(N1:N2,1)+eta;
    
    %%% referncias
     R = ones(N2-N1+1,1)*refsf(i);
    %R = refs(i+N1:i+N2); %%% uso de referencias futuras
    
    %%% calculo do incremento de controle timo    
    duAtual = Kdmc1*(R-f);
    
    %%% calculo da ao de controle real
    uAtual = duAtual + uAnt;
    
    %%% aplicar no sistema
    entradas(i) = uAtual;
    
    %%% atualizao
    
    uAnt = uAtual;
    duAnt = duAtual;
    
    
end

%% plots
t = (1:nit-N2-1)*Ts;



hf = figure
h=subplot(2,1,1)
plot(t,refs(1:nit-N2-1),'--','Color',cores(1,:),'LineWidth',tamlinha)
hold on
plot(t,saidas(1:nit-N2-1),'-','LineWidth',tamlinha,'Color',cores(2,:))
ylabel('Nvel (%)', 'FontSize', tamletra);
axis([0 50 0 7]);
grid on

legend('Sada','Referncia','Location','SouthEast');

set(h, 'FontSize', tamletra);

h=subplot(2,1,2)
plot(t,entradas(1:nit-N2-1),'-','Color',cores(2,:),'LineWidth',tamlinha)
hold on
plot(t,perts(1:nit-N2-1),'--','LineWidth',tamlinha,'Color',cores(3,:))
ylabel('Entradas (%)', 'FontSize', tamletra);
legend('Controle','Perturbao');
xlabel('Tempo (minutos)', 'FontSize', tamletra);
axis([0 50 -5 10]);
set(h, 'FontSize', tamletra);
grid on

% h=subplot(3,1,3)
% plot(t,erro(1:nit-N2-1),'LineWidth',tamlinha)
% title('Erro', 'FontSize', tamletra);
% xlabel('tempo', 'FontSize', tamletra);
% set(h, 'FontSize', tamletra);
hf.Position = tamfigura;

print('ex_tanque_com_ff_com_lambda2','-depsc')
print('ex_tanque_com_ff_com_lambda2_pb','-deps')