% para resposta ao degrau varios tipos
% set(0,'DefaultFigureWindowStyle','normal')
clc
clear all
close all

run('../../Bibliotecas/parametrosFiguras.m')


s =tf('s');
G = 4/(10*s+1);

Ts = 1;
Gz = c2d(G,Ts,'zoh');

gcoef = step(Gz,0:Ts:500*Ts);

hcoef = gcoef(2:end)-gcoef(1:end-1);

Nss = 66;
Gzfir = tf(hcoef(1:Nss)',1,Ts,'variable','z^-1');


% figure
% h = bodeplot(Gz,Gzfir)
% grid on
% title('Diagrama de Bode')
% xlabel('Frequncia')
% % ylabel({'Magnitude','Fase'})
% h.axesgrid.Ylabel = [{'Magnitude'},{'Fase'}]
% hl = legend('G_u(z)','G_{FIR}(z)')
% hl.Position = [0.7060 0.7811 0.1821 0.0869];

cores = gray(3);
cores = cores(1:end-1,:);


[mag1,pha1,w1] = bode(Gz);
[mag2,pha2,w2] = bode(Gzfir);

hf = figure
h1 = subplot(2,1,1)
semilogx(w1,20*log10(reshape(mag1,1,size(mag1,3))),'LineWidth',tamlinha,'Color',cores(1,:))
hold on
semilogx(w2,20*log10(reshape(mag2,1,size(mag2,3))),'--','LineWidth',tamlinha,'Color',cores(2,:))
semilogx(2*pi*[1/2/Ts, 1/2/Ts],[-1000 1000],'k','LineWidth',tamlinha)

ylabel('Magnitude (dB)');
grid on
ylim([-15 15])

title('Diagrama de Bode')

h2 = subplot(2,1,2)
semilogx(w1,(reshape(pha1,1,size(mag1,3))),'lineWidth',tamlinha,'Color',cores(1,:))
hold on
semilogx(w2,(reshape(pha2,1,size(mag2,3))),'--','lineWidth',tamlinha,'Color',cores(2,:))
semilogx(2*pi*[1/2/Ts, 1/2/Ts],[-1000 1000],'k','LineWidth',tamlinha)
ylabel('Fase (deg)');
xlabel('Frequncia (rad/s)');
grid on
ylim([-180 0])

hl = legend('G_u(z)','G_{FIR}(z)')
hl.Position = [0.7060 0.7811 0.1821 0.0869];

h1.FontSize = tamletra;
h2.FontSize = tamletra;
h2.FontSize = tamletra;

hf.Position = tamfigura

print('resposta_freq_FIR','-depsc')
print('resposta_freq_FIR_pb','-deps')

