% para resposta ao degrau de integradora e estavel aproximada
% satura no Ymax
close all
clear all
clc

run('../../Bibliotecas/parametrosFiguras.m')

a=0.8;
Ga=tf(1-a,[1 -a],1);

b=0.9;
Gb=tf(1-b,[1 -b],1);

G1=Ga*Gb*tf(0.5,[1 -1],1);


[y1,T1]=step(G1);

y1=50+y1;
fim=size(y1,1);
for ii=1:fim
if y1(ii) > 100
    y1(ii)=100;
end
end

% caso 1
c=0.988;
G2=Ga*Gb*tf(50*(1-c),[1 -c],1);
[y2,T2]=step(G2);



% caso 2
c=0.9945;
G2=Ga*Gb*tf(100*(1-c),[1 -c],1);
[y2,T2]=step(G2);


% caso 3
c=0.9974;
G2=Ga*Gb*tf(200*(1-c),[1 -c],1);
[y2,T2]=step(G2);


% caso 4
% sistema integrador com tau1=10 e Kv=1
% sistema estavel com mesmo tau1=10 e tau2=1000, com Ke=1000

G4=tf(1,[1 0]);
G5=tf(1,[10 1]);
G6=tf(1000,[1000 1]);

G2=Ga*Gb*tf(200*(1-c),[1 -c],1);
[y2,T2]=step(G2);


y2=50+y2;


c=0.92;
G3=Ga*Gb*tf(50*(1-c),[1 -c],1)*tf((1-c),[1 -c],1)*tf((1-c),[1 -c],1)*tf((1-c),[1 -c],1)*tf((1-c),[1 -c],1);

[y3,T3]=step(G3);

y3=50+y3;

cores = gray(3);
cores = cores(1:end-1,:);


hf = figure
h1=subplot(2,1,1);
plot(T1',y1','-','LineWidth',tamlinha,'Color',cores(1,:))
hold on
plot(T2',y2','--','LineWidth',tamlinha,'Color',cores(2,:))
legend('Integradora','Estvel lenta','Location','SouthEast')
axis([0 200 40 100]);
grid on
ylabel('Sada (%)', 'FontSize', tamletra);
%xlabel('tempo', 'FontSize', tamletra);
h1.YTick =[40 60 80 100];
set(h1, 'FontSize', tamletra);

dim = [0.1346 0.6329 0.3015 0.1929];
hr = annotation('rectangle',dim,'Color','black','LineStyle','--')    
% xl = [.3 .3];
% yl = [.3 .4];
% hl1 = annotation('line',xl,yl)

h=subplot(2,1,2);
plot(T1',y1','-','LineWidth',tamlinha,'Color',cores(1,:))
hold on
plot(T2',y2','--','LineWidth',tamlinha,'Color',cores(2,:))
grid on
legend('Integradora','Estvel lenta','Location','SouthEast')
axis([0 80 40 80]);
ylabel('Sada (%)', 'FontSize', tamletra);
xlabel('Tempo (min)', 'FontSize', tamletra);
set(h, 'FontSize', tamletra);

hf.Position = tamfigura;

print('compara_resposta_degrau_int_estavel','-depsc')
% print('compara_resposta_degrau_int_estavel_pb','-deps')



hf = figure
h=subplot(1,1,1);
plot(T1',y1','LineWidth',tamlinha,'Color',cores(1,:))
grid on
%legend('integradora','estvel lenta','Location','SouthEast')
axis([0 200 40 100]);
ylabel('Sada (%)', 'FontSize', tamletra);
xlabel('Tempo (min)', 'FontSize', tamletra);
set(h, 'FontSize', tamletra);

hf.Position = tamfigura;

print('resposta_degrau_int_limitada','-depsc')
% print('resposta_degrau_int_limitada_pb','-deps')


