% Codigo que implementa DMC

clc;
clear all;
close all;
% set(0,'DefaultFigureWindowStyle','normal')

run('../../Bibliotecas/parametrosFiguras.m')
% definicao do processo 



% caso 1 ordem lento e Ts pequeno
tau=10;
Pc=tf(tau,[tau 1]);
Ts=1;

Pd=c2d(Pc,Ts);

aa=exp(-Ts/tau);
A = [aa]; 
B = [1-aa]; % B tem d colunas com zeros por causa do atraso


%Parametros para calcular o modelo do processo, pode se colocar erro de
%modelagem definindo o atraso e A e B difernete do modelo
dp=0;
Ap = 1;
Bp=Ts; 

% caso 2 ordem lento e Ts pequeno
%Pc=tf(500,[500 1])*tf(1,[10 1]);

Pc=tf(10,[10 1]);



Pd=c2d(Pc,Ts);

% caso 4 ordem lento e Ts pequeno
%Pc=tf(100,[100 1])*tf(1,[10 1])*tf(1,[20 1])*tf(1,[5 1]);


%Pd=c2d(Pc,Ts);

%Parametros para calcular o modelo do processo, pode se colocar erro de
%modelagem definindo o atraso e A e B difernete do modelo

dp=0;
Ap = 1;
Bp=Ts; 

% calcula o numero de coeficientes dos polinomios usados para simulacao

na=size(Ap,2); % 'na' recebe o numero de colunas de Ap (neste exemplo = 2 colunas)
nb=size(Bp,2); % 'nb' recebe o numero de colunas de Bp (neste exemplo = 6 colunas)


% definicao dos vetores onde se guardam as informaes passadas da sada y e entradas u

y_ant=zeros(1,na); % numero de colunas de na
u_ant=zeros(1,nb);


% N = nmero de pontos da resposta ao degrau

N=80;
g=step(Pd,N);


% definio do vetor dos incrementos de controle passados para resposta livre

u_livre=zeros(1,N);


% definio dos horizontes
% Sempre N1=1 e N2  definido como 'p' de predio, tal que p <N 
p=30;

% horizonte de controle 'Nu' ou 'm', sempre m<=p
m=5;

% calcula matriz G

G=zeros(p,m); % inicializa a matriz G s com zeros, p linhas e m colunas
G(:,1)=g(1:p); % a primeira coluna da matriz G recebe as amostras da resposta ao degrau
%pegou-se p amostras(20), menos que o vetor N, 30 elementos


for i=2:m % da segunda coluna at a m-sima culuna
    ga=[zeros(1,i-1) g(1:p-i+1)']; % ga'  o vetor coluna que pega o valor da coluna  esquerda e da um shift com '0' pra baixo
    G(:,i)=ga';
end

% define simulao
pontos=100;

% define parametros do DMC
lambda=1;


% Calculo da Matriz Mn

Mn=(G'*G + lambda*eye(m)); 

% Inverte Mn, multiplica por G' e pega a primeira linha

Mn1=inv(Mn)*G'; % Mn1  a matriz de ganho k, deltaU = k(w-f)
qn=Mn1(1,:); % pega s a primeira linha de Mn1 ( k1 )


% define vetores de pontos elementos para simular
% yp do proceso, y predio, u controle r=ref 

% controle para graficos
u=zeros(1,pontos);

%vetor de saidas

yp=zeros(1,pontos); %y processo
ypr=zeros(1,pontos); %y processo contabilizando a perturbao

% def referencia

w=[zeros(1,10) 10*ones(1,pontos-10)]; % vetor com 220 pontos, os 10 primeiros so '0' e o restante so '1'

% coloca filtro 1 ordem

af=0;
bf=0; % parametro para ajuste do filtro de referencia

r=filter([1 -bf]*(1-af),(1-bf)*[1 -af],w); %os dados do vetor w so filtrados por um filtro de 1 ordem
% F(z)= (1-af)/(z-af), descrito pelo numerador (1-af) e denominador [1 -af].

% inicializa

inc_u=0;


% comeo do lao de controle

for k=1:pontos
   
% calculo da sada do processo

    yp(k)=Ap*y_ant'+Bp*u_ant' + 0.*rand; % y processo

% perturbao determinstica para a sada
if k>pontos/2 % a pert entra entre os pontos 150 e 220
 ypr(k)=yp(k)+5; %perturbao constante tipo degrau
else
 ypr(k)=yp(k);  %ypr  a variavel de processo com a perturbacao
end


% atualiza a sada para simulao do proximo passo

if na==1
    y_ant=yp(k);
else
    aux_y=y_ant(1:na-1); % aux_y recebe do primeiro ao penultimo elemento de y_ant
    y_ant=[yp(k) aux_y]; % y_ant recebe o yp(atual) e da um shift de segundo elemento at o ultimo com os elementos passados de y_ant( descarta o ultimo elemento )
end




% Calcula a predicao para o DMC

   f=zeros(1,p); % inicializa o vetor f com 'p' zeros. (20 no caso)

      for kk=1:p
% Monta um vetor com as parcelas (gkk+i - gkk)
% o calculo se faz em dois passos porque quando o indice kk+i passa de N,
% nao teriamos valores no vetor g para esse valor, mas como se assume que a planta  estavel
% e N  grande, todos os g(i) = g(N) para i>N

      for i=1:N-p % N periodos de amostragem que a planta se estabiliza, p  o horizonte
             vect_g(i)=g(kk+i)-g(i); 
         end
         for i=N-p+1:N
             vect_g(i)=g(N)-g(i);
         end
         f(kk)=ypr(k)+vect_g*u_livre';
      end

% considera ref futura cte

ref=r(k)*ones(1,p)';


% calcula o controle

inc_u=qn*(ref-f'); % qn = k1, deltaU = k(W - f)
if k==1
    u(k)=inc_u;
else
    u(k)=u(k-1)+ inc_u;
end

% atualizacao do vetor de controle

aux_u=u_ant(1:nb-1);
u_ant=[u(k) aux_u];

%atualizacao de  u_livre
% u_livre= [du(k-1) du(k-2) ..... du(k-N)]

aux_2=u_livre(1:N-1);
u_livre=[inc_u aux_2];


end


nm=pontos;

% parameters for figures
% tamletra=12;
% tamletra=12; 

cores = gray(3);
cores = cores(1:end-1,:);


hf = figure
h=subplot(2,1,1);
plot(30+ypr(1:nm),'-','LineWidth',tamlinha,'Color',cores(1,:));
grid on
hold
%plot(t(1:nm),y1(1:nm),'-');
plot(30+w(1:nm),'--','LineWidth',tamlinha,'Color',cores(2,:));


ylabel('Controlada (%)', 'FontSize', tamletra);
axis([0 100 29 46]);
set(h, 'FontSize', tamletra);
%title('(b)', 'FontSize', tamletra);
%axis([0 pontos -0.1 0.7])
legend('Controlada','Referncia','Location','SouthEast')


h=subplot(2,1,2);
plot(47+ u(1:nm),'-','LineWidth',tamlinha,'Color',cores(1,:));
hold
%plot(t(1:nm),u1(1:nm),'-');
grid on
ylabel('Manipulada (%)', 'FontSize', tamletra);
xlabel('Tempo (minutos)', 'FontSize', tamletra);
%axis([0 pontos -2 1])
axis([0 100 44 54]);
set(h, 'FontSize', tamletra);

hf.Position = tamfigura;
print('controle_dmc_planta_integradora_modelo_estavel','-depsc')
print('controle_dmc_planta_integradora_modelo_estavel_pb','-deps')
