%%% Exemplo duplo integrador do capítulo GPC SISO
%%% cálculo do ganho irrestrito
%%% cálculo das funções de transferência equivalentes.

clear all
close all
clc


addpath('../../Bibliotecas/')

%% Modelo da planta
A = [1 -0.9];
B = [0.3];
Bq = [0 B];
C = 1;
C = poly([0.7]);
C = poly([0.7 0.7 0.1]);

d=8;
dq = d;

nb = size(B,2)-1; % ordem do polinômio B
na = size(A,2)-1; % ordem do polinômio A
nbq = size(Bq,2)-1; % ordem do polinômio Bq
nC = size(C,2)-1; % ordem do polinômio C


N1 = 1; %% horizonte de predição inicial
N2 = 50; %% horizonte predição
Ny = N2-N1+1;
Nu = 10;

%% montagem das matrizes
Btil = conv(B,[zeros(1,d) 1]); % incorporação do atraso no numerador B
Bqtil = conv(Bq,[zeros(1,dq) 1]); % incorporação do atraso no numerador Bq


G = zeros(N2,N2); % matriz dinâmica G
H = zeros(N2,nb+d);
Fbar = zeros(N2,max(nC-1,na)+1);
nF = size(Fbar,2);


%% parte simbolica
up = sym('up',[nb+d,1]);
uf = sym('uf',[N2,1]);

yp = sym('y',[max(nC-1,na)+1,1]);

[E,F] = diofantinaC(conv(A,[1 -1]),C,1,N2);

Cs = sym(C);
Bs = sym(Btil);
% Es = sym(E)
Fs = sym(F);

pred = sym(zeros(N2,1));
for i=1:N2
    du = [flip(uf(1:i));up];
    
    pred(i,1) = sym(conv(E(i,1:i),Btil))*du + Fs(i,:)*yp;
    
    for j=1:nC
        if(i-j>0)
            pred(i,1) = pred(i,1) - C(j+1)*pred(i-j,1);
        else
            pred(i,1) = pred(i,1) - C(j+1)*yp(-(i-j)+1);
        end
    end
    
    
    %%% separando os coeficientes
    for j=1:size(up,1)
        [temp,t] = coeffs(pred(i,1),up(j));
        if(length(temp)>1)
            H(i,j)=eval(temp(1));
        end        
    end
    
    for j=1:size(uf,1)
        [temp,t] = coeffs(pred(i,1),uf(j));
        if(length(temp)>1)
            G(i,j)=eval(temp(1));
        end        
    end
    
    for j=1:size(yp,1)
        [temp,t] = coeffs(pred(i,1),yp(j));
        if(length(temp)>1)
            Fbar(i,j)=eval(temp(1));
        end        
    end
    
end

G = G(N1:N2,1:Nu);
Fbar = Fbar(N1:N2,:);
H = H(N1:N2,:);


%%
load('temp5.mat')

[sum(sum(abs(G-G1))), sum(sum(abs(Fbar-F1))), sum(sum(abs(H-H1)))]



