%exemplo 55 - nivel e temperatura 
clear all
close all

N_entradas = 3; % nmero de entradas da planta - manipuladas
N_saidas = 3; %nmero de saidas da planta - controladas
N_perturbacoes = 0;

s = tf('s');
% Definir os modelos que relacionam {saida x,entrada y};
G{1,1} = 4.05/(50*s+1)*exp(-27*s);
G{1,2} = 1.77/(60*s+1)*exp(-28*s);
G{1,3} = 5.88/(50*s+1)*exp(-27*s);
G{2,1} = 5.39/(50*s+1)*exp(-18*s);
G{2,2} = 5.72/(60*s+1)*exp(-14*s);
G{2,3} = 6.9/(40*s+1)*exp(-15*s);
G{3,1} = 4.38/(33*s+1)*exp(-20*s);
G{3,2} = 4.42/(44*s+1)*exp(-22*s);
G{3,3} = 7.2/(19*s+1);

Ts = 1.0; %perodo de amostragem
Nrp = [300 300 300]; %horizonte de regime permanente - dimenso 1 x N_saidas

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%respostas ao degrau
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for i = 1:N_saidas
    for j = 1:N_entradas
        g{i,j} = step(G{i,j},0:Ts:(Nrp(i)-1)*Ts);
    end
    for j = 1:N_perturbacoes
        gp{i,j} = step(Gp{i,j},0:Ts:(Nrp(i)-1)*Ts);
    end
end

t = Ts*(0:max(Nrp)-1)';

tamletra=20;
tamnum=20;
figure
plot(t,g{1,1}(1:Nrp(1)),'-',t,g{1,2}(1:Nrp(1)),'-',t,g{1,3}(1:Nrp(1)),'-','LineWidth',2)
plot(t,g{2,1}(1:Nrp(2)),'-',t,g{2,2}(1:Nrp(2)),'-',t,g{2,3}(1:Nrp(2)),'-','LineWidth',2)
plot(t,g{3,1}(1:Nrp(3)),'-',t,g{3,2}(1:Nrp(3)),'-',t,g{3,3}(1:Nrp(3)),'-','LineWidth',2)
%title(['y1' ' e Referncia do Sistema'], 'FontSize', tamletra)
legend('y1 x u1','y1 x u2','y2 x u2','Location','SouthEast')
axis([0 max(Nrp)*Ts -5.0 8.0]);
 %   ylabel('Sadas e Referncias do Sistemas', 'FontSize', tamletra);
xlabel('Tempo (s)', 'FontSize', tamletra);
ylabel('Controladas', 'FontSize', tamletra);
set(gca,'FontSize',tamnum);
grid on
print -depsc results_degrau_55.eps



