%exemplo 56 - nivel e temperatura 
clear all
close all

N_entradas = 2; % nmero de entradas da planta - manipuladas
N_saidas = 2; %nmero de saidas da planta - controladas
N_perturbacoes = 1;

s = tf('s');
% Definir os modelos que relacionam {saida x,entrada y};
G{1,1} = 1.43/(7.5*s+1)*exp(-s);
G{1,2} = -4.5/(13.4*s+1)*exp(-s);
G{2,1} = 0*s;
G{2,2} = 5.72/(14.7*s+1);

% Definir os modelos que relacionam {saida x,perturbao z};
Gp{1,1} = 2.1/(13*s+1)*exp(-s);
Gp{2,1} = -3.12/(14.7*s+1);

Ts = 1.0; %perodo de amostragem
Nrp = [30 50]; %horizonte de regime permanente - dimenso 1 x N_saidas

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%respostas ao degrau
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Nrp = [100 100];
for i = 1:N_saidas
    for j = 1:N_entradas
        g{i,j} = step(G{i,j},0:Ts:(Nrp(i)-1)*Ts);
    end
    for j = 1:N_perturbacoes
        gp{i,j} = step(Gp{i,j},0:Ts:(Nrp(i)-1)*Ts);
    end
end

t = Ts*(0:max(Nrp)-1);

tamletra=20;
tamnum=20;
figure
plot(t,g{1,1}(1:Nrp(1)),'-',t,g{1,2}(1:Nrp(1)),'-',t,g{2,2}(1:Nrp(2)),'-','LineWidth',2)
%title(['y1' ' e Referncia do Sistema'], 'FontSize', tamletra)
legend('y1 x u1','y1 x u2','y2 x u2','Location','SouthEast')
axis([0 max(Nrp)*Ts -5.0 8.0]);
 %   ylabel('Sadas e Referncias do Sistemas', 'FontSize', tamletra);
xlabel('Tempo (s)', 'FontSize', tamletra);
ylabel('Controladas', 'FontSize', tamletra);
set(gca,'FontSize',tamnum);
grid on
print -depsc results_degrau_56.eps

figure
plot(t,gp{1,1}(1:Nrp(1)),'-',t,gp{2,1}(1:Nrp(1)),'-','LineWidth',2)
%title(['y1' ' e Referncia do Sistema'], 'FontSize', tamletra)
legend('y1','y2','Location','SouthEast')
axis([0 max(Nrp)*Ts -4.0 3.0]);
 %   ylabel('Sadas e Referncias do Sistemas', 'FontSize', tamletra);
xlabel('Tempo (s)', 'FontSize', tamletra);
ylabel('Controladas', 'FontSize', tamletra);
set(gca,'FontSize',tamnum);
grid on
print -depsc results_degrau_56_per.eps

