clear all
close all
clc

addpath('../../Bibliotecas/')
run('../../Bibliotecas/parametrosFiguras.m')
%% regime estático CSTR

Caf = [4.5 5.1 5.7];

u = linspace(0,1.5,1000);

%%% livro
k1 = 0.8433;
k2 = k1;
k3 = 0.1123;

%%

Ca0 = zeros(size(Caf,2),size(u,2));
Cb0 = zeros(size(Caf,2),size(u,2));

for i=1:size(Caf,2)
    x = zeros(2,size(u,2));
    for j=1:size(u,2)
        x(:,j) = roots([k3, (u(j)+k1),-Caf(i)*u(j)]);
        
        if(x(1,j)>=0)
            Ca0(i,j) = x(1,j);
        else
            Ca0(i,j) = x(2,j);
        end
        Cb0(i,j) = (k1*Ca0(i,j))/(k2+u(j));
    end    
end
%%
cores = gray(4);
cores = cores(1:end-1,:);

hf = figure
h = subplot(2,1,1)
plot(u,Ca0(1,:),'LineWidth',tamlinha,'Color',cores(1,:))
hold on
plot(u,Ca0(2,:),'--','LineWidth',tamlinha,'Color',cores(2,:))
plot(u,Ca0(3,:),'-.','LineWidth',tamlinha,'Color',cores(3,:))

ylabel('C_a (mol/l)','FontSize', tamletra)
ylim([0 3.3]) 

grid on
set(h, 'FontSize', tamletra);

h = subplot(2,1,2)
plot(u,Cb0(1,:),'LineWidth',tamlinha,'Color',cores(1,:))
hold on
plot(u,Cb0(2,:),'--','LineWidth',tamlinha,'Color',cores(2,:))
plot(u,Cb0(3,:),'-.','LineWidth',tamlinha,'Color',cores(3,:))

ylabel('C_b (mol/l)','FontSize', tamletra)
xlabel('F/V (1/mol)','FontSize', tamletra)
ylim([0 1.28])


grid on
set(h, 'FontSize', tamletra);


legend('Caf=4.6','Caf=5.1','Caf=5.6','Location','SouthEast')

hf.Position = tamfigura;
% hl.Position = [0.6488 0.4766 0.2536 0.2371];
print('CSTR_isotermico_estatico','-depsc')

