clear all, 
close all, 
clc

addpath('../Bibliotecas/')
%%
a1 = 0.1;
a2 = 0.4;
a3 = 0.5;
a4 = a3;

A = [(1-a2), 0;
     a2, 1]
B = diag([a1,a3])
Bq = [0;-a4]
C = eye(2)
Cq = zeros(2,1);


G = [C*B zeros(2,2);
     C*(eye(2)+A)*B, C*B;
     C*(eye(2)+A+A^2)*B,C*B]
 

Gtxt = matrix2tex(G)
 
F = [C*(eye(2)+A), -C*(A);
     C*(eye(2)+A+A^2), -C*(A+A^2);
     C*(eye(2)+A+A^2+A^3), -C*(A+A^2+A^3)]
 
Ftxt = matrix2tex(F)


Qyi = diag([0.8,1]);
Qui = diag([1,0.6]);

Qy = blkdiag(Qyi,Qyi,Qyi);
Qu = blkdiag(Qui,Qui);

K = (G'*Qy*G+Qu)\G'*Qy

Ktxt = matrix2tex(K)
Ktxt_trans = matrix2tex(K')
Ktxt_trans = matrix2tex(K(1:2,:)')

Gq = [Cq zeros(2,1) zeros(2,1);
      C*Bq+Cq, Cq, zeros(2,1);
      C*(eye(2)+A)*Bq+Cq,C*Bq+Bq,Cq]

Gqtxt = matrix2tex(Gq)

Fq = [C*Bq+Cq,-C*Bq;
      C*(eye(2)+A)*Bq+Cq,-C*(eye(2)+A)*Bq;
      C*(eye(2)+A+A^2)*Bq+Cq,-C*(eye(2)+A+A^2)*Bq]

Fqtxt = matrix2tex(Fq)


%%% controlador equivalente
K1 = K(1:2,:)
KF = K(1:2,:)*F
KF0 = KF(:,1:2)
KF1 = KF(:,3:4)

KFtxt = matrix2tex(KF)

KFq = K1*Fq
KFq0 = KFq(:,1)
KFq1 = KFq(:,2)

KFqtxt = matrix2tex(KFq)

Kr = K1*repmat(eye(2),[3,1])

Krtxt = matrix2tex(Kr)

Ac = [eye(2) -KF1,-KFq1;
      zeros(2,5);
      zeros(1,5)]
Bc = [Kr, -KF0,-KFq0;
      zeros(2,2),eye(2,2),zeros(2,1);
      zeros(1,2+2),eye(1)]
Cc = [eye(2),-KF1,-KFq1]
Dc = [Kr,-KF0,-KFq0]


Actxt = matrix2tex(Ac)
Bctxt = matrix2tex(Bc)
Cctxt = matrix2tex(Cc)
Dctxt = matrix2tex(Dc)


Amf = [A-B*KF0,B*Cc;
       [-KF0;eye(2);zeros(1,2)], Ac]
Bmf = [B*Kr,(Bq-B*KFq0);
       Kr,-KFq0;
       zeros(2,3);
       zeros(1,2),eye(1)]
Cmf = [C, zeros(2,5);
       -KF0,Cc;
       -C,zeros(2,5)]
Dmf = [zeros(2,2) Cq;
       Kr, -KFq0;
       eye(2),-Cq]
   
sysmf1 = ss(Amf,Bmf,Cmf,Dmf,1)

Amftxt = matrix2tex(Amf)
Bmftxt = matrix2tex(Bmf)
Cmftxt = matrix2tex(Cmf)
Dmftxt = matrix2tex(Dmf)




% figure
% bodemag(sysmf1)

Ac2 = [eye(2), -KF1;
      zeros(2,4)]
Bc2 = [Kr, -KF0;
      zeros(2,2),eye(2,2)]
Cc2 = [eye(2),-KF1]
Dc2 = [Kr,-KF0]


Amf2 = [A-B*KF0,B*Cc2;
       [-KF0;eye(2)], Ac2]
Bmf2 = [B*Kr,Bq;
       Kr,zeros(2,1);
       zeros(2,3);]
Cmf2 = [C, zeros(2,4);
       -KF0,Cc2;
       -C,zeros(2,4)]
Dmf2 = [zeros(2,2) Cq;
       Kr, zeros(2,1);
       eye(2),-Cq]
   
sysmf2 = ss(Amf2,Bmf2,Cmf2,Dmf2,1)
 
% figure
% bodemag(sysmf1,sysmf2)

%% sintonia 2
 
 G = [C*B zeros(2,1);
     C*(eye(2)+A)*B, C*B(:,1);
     C(2,:)*(eye(2)+A+A^2)*B,C(2,:)*B(:,1)]
 

 Gtxt = matrix2tex(G)
 
F = [C*(eye(2)+A), -C*(A);
     C*(eye(2)+A+A^2), -C*(A+A^2);
     C(2,:)*(eye(2)+A+A^2+A^3), -C(2,:)*(A+A^2+A^3)]
 
Ftxt = matrix2tex(F)
 
Qyi = diag([0.8,1]);
Qui = diag([1,0.6]);

Qy = blkdiag(Qyi,Qyi,1);
Qu = blkdiag(Qui,1);


K = (G'*Qy*G+Qu)\G'*Qy

Ktxt = matrix2tex(K)
Ktxt1 = matrix2tex(K(1:2,:))
 
%%